package tw.brad.book.mysensor;

import java.util.ArrayList;
import java.util.HashMap;

import android.app.ListActivity;
import android.content.Intent;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import android.widget.SimpleAdapter;

public class MainActivity extends ListActivity {
	private ListView lview;
	private String[] from = {"item_title"};
	private int[] to = {R.id.item_title};
	private ArrayList<HashMap<String,String>> data;
	private SimpleAdapter adapter;
	private String[] items_title = {
		"三軸加速感應器", "重力加速度感應器", 
		"磁極方位感應器","光線感應器",
		"溫度感應器", "濕度感應器",
		"大氣壓力感應器"
	};
	static SensorManager smgr;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		smgr = (SensorManager) getSystemService(SENSOR_SERVICE);
		
		data = new ArrayList<HashMap<String,String>>();
		for (int i=0; i<items_title.length; i++){
			HashMap<String,String> temp = new HashMap<String, String>();
			temp.put(from[0], items_title[i]);
			data.add(temp);
		}
		
		SimpleAdapter adapter = new SimpleAdapter(this, data, R.layout.menuitem, from, to);
		lview = getListView();
		lview.setAdapter(adapter);
		lview.setOnItemClickListener(new OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int index, long arg3) {
				switch (index){
					case 0: gotoAccelerometer(); break;
					case 1: gotoGravity(); break;
					case 2: gotoMagneticField(); break;
					case 3: gotoLight(); break;
					case 4: gotoTemperature(); break;
					case 5: gotoHumidity(); break;
					case 6: gotoPressure(); break;
				}
			}
		});
	}
	private void gotoAccelerometer(){
		Intent it = new Intent(this, AccelerometerTest.class);
		startActivity(it);
	}
	private void gotoGravity(){
		Intent it = new Intent(this, GravityTest.class);
		startActivity(it);
	}
	private void gotoMagneticField(){
		Intent it = new Intent(this, MagneticFieldTest.class);
		startActivity(it);
	}
	private void gotoLight(){
		Intent it = new Intent(this, LightTest.class);
		startActivity(it);
	}
	private void gotoTemperature(){
		Intent it = new Intent(this, TemperatureTest.class);
		startActivity(it);
	}
	private void gotoHumidity(){
		Intent it = new Intent(this, HumidityTest.class);
		startActivity(it);
	}
	private void gotoPressure(){
		Intent it = new Intent(this, PressureTest.class);
		startActivity(it);
	}
	
	
}
