/*
 * MapTest: for Google Maps V2
*/
package tw.idv.jameschen;

import java.util.Iterator;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.location.Criteria;
import android.location.GpsSatellite;
import android.location.GpsStatus;
import android.location.GpsStatus.Listener;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.ToggleButton;

import com.google.android.gms.common.GooglePlayServicesNotAvailableException;
import com.google.android.gms.location.LocationStatusCodes;
import com.google.android.gms.maps.CameraUpdate;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.GoogleMap.OnMarkerClickListener;
import com.google.android.gms.maps.MapFragment;
import com.google.android.gms.maps.MapsInitializer;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;

public class MapGpsTest extends Activity implements OnMarkerClickListener, LocationListener, Listener {
	private GoogleMap gmap;
	private LatLng myLoc;
	private Button btn_query, btn_zoomIn, btn_zoomOut;
	private EditText edLongitude; // g
	private EditText edLatitude; // n
	private ToggleButton btnToggleTracking;
	private TextView tvGPSinfo;
	
	private int initZoomLevel = 15;	

	// x_pJ: 25.0402226, 121.228626
	// ԯqjD: 24.143993, 120.731174
	// ץj:  24.0910042, 120.7167612
	
	private double dLng2 = 120.731174;// w]g 
	private double dLat2 =  24.143993;  // w]n
	private double dLng = 120.713000;// w]g 
	private double dLat =  24.095000;  // w]n
	private String myTitle = "ץj";
    private LatLng myPos = new LatLng( dLat, dLng);
	private String myTitle2 = "ԯqj";
    private LatLng myPos2 = new LatLng( dLat2, dLng2);
    private Marker myMarker, myMarker2;
    
    // --------------------------------------
    private LocationManager locMgr;
	private String strLocationPrivider;
    // --------------------------------------
	
	@Override
	protected void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		setContentView(R.layout.main);
		//
		try {
			MapsInitializer.initialize(this);
	       // old version ONLY !
		   //} catch (GooglePlayServicesNotAvailableException e) {
		   //	e.printStackTrace();
		}
		finally {
			// Nothing
		}
        // Find out the MapFragement, if the gmap is null, then something is WRONG!
		gmap = ((MapFragment) getFragmentManager().findFragmentById(R.id.map)).getMap();
		if (gmap != null) {
			// еm
			MarkerOptions opt1 = new MarkerOptions()
					                .position(myPos)
					                .title(myTitle)
					                .snippet("Test Snippet...")
					                .icon(BitmapDescriptorFactory.fromResource(
					                		R.drawable.pointer_72));
			myMarker = gmap.addMarker( opt1);
			//
			MarkerOptions opt2 = new MarkerOptions()
            						.position(myPos2)
            						.title(myTitle2)
            						.snippet("Test Snippet 222...");
			myMarker2 = gmap.addMarker( opt2);
			//
			gmap.setOnMarkerClickListener(this);
		}
		//
 	    // 1. ]wp !
		btn_query = (Button) findViewById(R.id.btnQuery);
		btn_zoomIn = (Button) findViewById(R.id.btnZoomIn);
		btn_zoomOut = (Button) findViewById(R.id.btnZoomOut);
		edLatitude = (EditText) findViewById(R.id.edLatitude);
		edLongitude = (EditText) findViewById(R.id.edLongtitude);
		btnToggleTracking = (ToggleButton)findViewById(R.id.btnToggleTracking);
		tvGPSinfo = (TextView) findViewById(R.id.tvGPSinfo);
		
		// 2. ]waYjpPI
		refreshMap( dLat, dLng);
				
		// dߨƥBz
		btn_query.setOnClickListener(new Button.OnClickListener() {
			// @Override
			public void onClick(View v) {

				if (edLongitude.getText().toString().equals("")
						|| edLatitude.getText().toString().equals("")) {
					showDialog("gשνn׶gT!");
				} else {
					// oJgn, sܼ
					dLng = Double.parseDouble(edLongitude.getText().toString());
					dLat = Double.parseDouble(edLatitude.getText().toString());
					// se
					refreshMap(dLat, dLng);
				}
			}
		});

		//jƥBz
		btn_zoomIn.setOnClickListener(new Button.OnClickListener() {
			// @Override
			public void onClick(View v) {
				// W[Yż: Nܼƭȥ[ 1
				initZoomLevel ++;
				// øa
				zoomMap(initZoomLevel);
			}
		});
		
		//YpƥBz
		btn_zoomOut.setOnClickListener(new Button.OnClickListener() {
			// @Override
			public void onClick(View v) {
				// Yż: Nܼƭȴ 1
				initZoomLevel --;
				// øa
				zoomMap(initZoomLevel);
			}
		});
		
		//
		btnToggleTracking.setOnCheckedChangeListener( new ToggleButton.OnCheckedChangeListener(){

			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				if (isChecked) 
					turnOnTracking();
				else
					turnOffTracking();
			}});
	}

	// øa
	public void refreshMap(double dLat, double dLng) {
		// wI
		myLoc = new LatLng( dLat, dLng);
	    
		//CameraUpdate center =  CameraUpdateFactory.newLatLng(myLoc);
        //gmap.moveCamera(center);
		// ]waY
        //CameraUpdate zoom=CameraUpdateFactory.zoomTo(initZoomLevel);
        //gmap.animateCamera(zoom);

		CameraUpdate update = CameraUpdateFactory.newLatLngZoom( myLoc, initZoomLevel);
        gmap.animateCamera(update);

	}

	public void zoomMap(int zoomLevel) {
		// ]waY
        CameraUpdate zoom=CameraUpdateFactory.zoomTo(zoomLevel);
        gmap.animateCamera(zoom);
	}

	// ܹܮ !!
	private void showDialog(String mess) {
		new AlertDialog.Builder(MapGpsTest.this).setTitle("Message")
				.setMessage(mess)
				.setNegativeButton("Tw", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int which) {
					}
				}).show();
	}

	@Override
	public boolean onMarkerClick(Marker marker) {
		// TODO Auto-generated method stub
		marker.setTitle("Clicked!");
		return false;
	}
	
	// -----------------------------------------
	// Lab0101 -
	// -----------------------------------------
	public void turnOnTracking() {
		try {
			Criteria mCriteria01 = new Criteria();
			mCriteria01.setAccuracy(Criteria.ACCURACY_FINE);
			mCriteria01.setAltitudeRequired(false);
			mCriteria01.setBearingRequired(false);
			mCriteria01.setCostAllowed(true);
			mCriteria01.setPowerRequirement(Criteria.POWER_LOW);
			// om޲z
			locMgr = (LocationManager) getSystemService(LOCATION_SERVICE);
			// ھڱӨǫΪmAȨӷ
			strLocationPrivider = locMgr.getBestProvider(mCriteria01, true);
			// 
			Location location1, location2;
			// ŪW@wm
			location1=locMgr.getLastKnownLocation(LocationManager.GPS_PROVIDER);
			location2=locMgr.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);
			if (location1 != null && location2 != null) {
				if (location1.getTime() >= location2.getTime())
				   updateLocation(location1);
				else
				   updateLocation(location2);
			}
			else if (location1 != null) {
				updateLocation(location1);
			}
			else if (location2 != null){
				updateLocation(location2);
			}
			else {
				// No Last-Known Location !
			}
		    // Umsƥ
		    locMgr.requestLocationUpdates(LocationManager.GPS_PROVIDER, 100, 0, this);
		    locMgr.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 1000, 0, this);
		    
		    // U GPS Aʨƥ
		    locMgr.addGpsStatusListener(this);
		    
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	//
	public void turnOffTracking() {
		// ƥU
		locMgr.removeUpdates(this);
		locMgr.removeGpsStatusListener(this);
	}	
	//
	private void updateLocation(Location location) {
		// In case, location is null ?
		if (location == null) return;
		// se
		refreshMap( location.getLatitude(), location.getLongitude());
	}

	// -----------------------------------------
	// LocationListener
	// -----------------------------------------
	@Override
	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
		edLongitude.setText( String.format("%.6f", location.getLongitude()));
		edLatitude.setText( String.format("%.6f", location.getLatitude()));
		//
		updateLocation(location);
	}

	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO Auto-generated method stub
	}

	@Override
	public void onProviderEnabled(String provider) {
		if (provider.equals(LocationManager.GPS_PROVIDER)) {
			tvGPSinfo.setText("GPSw}(1)!");
		}
	}

	@Override
	public void onProviderDisabled(String provider) {
		if (provider.equals(LocationManager.GPS_PROVIDER)) {
			tvGPSinfo.setText("GPSw(1)!");
		}
	}
	// -----------------------------------------
	// ...... End of LocationListener
	// -----------------------------------------

	
	// -----------------------------------------
	// GpsStatusListener
	// -----------------------------------------
	@Override
	public void onGpsStatusChanged(int event) {
		switch (event)  {
		case GpsStatus.GPS_EVENT_FIRST_FIX:
            tvGPSinfo.setText("GPSw짹!");
			break;
		case GpsStatus.GPS_EVENT_SATELLITE_STATUS:
			GpsStatus status=locMgr.getGpsStatus(null);
            Iterable<GpsSatellite> sats = status.getSatellites();
            Iterator<GpsSatellite> iter = sats.iterator();
            int counter = 0;
            while (iter.hasNext()) {
            	counter++;
            	iter.next();
            }
            tvGPSinfo.setText("GPSìPӼơG"+counter);
			break;
		case GpsStatus.GPS_EVENT_STARTED:
            tvGPSinfo.setText("GPSw}(2)!");
			break;
		case GpsStatus.GPS_EVENT_STOPPED:
            tvGPSinfo.setText("GPSw(2)!");
			break;
		}
	}
	// -----------------------------------------
	// ...... End of GpsStatusListener
	// -----------------------------------------
}